/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * ___________________
 *
 * Copyright 2012 Adobe Systems Incorporated
 * All Rights Reserved.
 *
 * NOTICE: All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any. The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *
 **************************************************************************/

// event object

function Event()
{
};

Event.prototype =
{
    /*
     * get & set return code
     */ 
    get rc()
    {
        var ret;
        var successCB = function(_val)
        {
            if (_val == 1)
                ret = true;
            else
                ret = false;
        };
        var errorCB = function()
        {
            ret = undefined;
        };
        
        require('cordova/exec')(successCB, errorCB, "Event", "getRC", []);
        return ret;
    },
    set rc(_val)
    {
        var args = {};
        args.val = _val;
        require('cordova/exec')(null, null, "Event", "setRC", [args]);
    },
    
    /*
     * get & set change
     */
    get change()
    {
        var ret;
        var successCB = function(_val)
        {
            ret = _val;
        };
        var errorCB = function()
        {
            ret = undefined;
        };
        
        require('cordova/exec')(successCB, errorCB, "Event", "getChange", []);
        return ret;
    },
    set change(_val)
    {
        var args = {};
        args.val = _val;
        require('cordova/exec')(null, null, "Event", "setChange", [args]);
    },
    
    /*
     * get target field
     */
    get target()
    {
        var ret;
        var successCB = function(_name)
        {
            ret = new Field(_name);
        };
        var errorCB = function()
        {
            ret = undefined;
        };
        
        require('cordova/exec')(successCB, errorCB, "Event", "getTarget", []);
        return ret;
    },
    
    /*
     * get selection start
     */ 
    get selStart()
    {
        var ret;
        var successCB = function(_val)
        {
            ret = _val;
        };
        var errorCB = function()
        {
            ret = undefined;
        };
        
        require('cordova/exec')(successCB, errorCB, "Event", "getSelStart", []);
        return ret;
    },

    /*
     * get selection end
     */ 
    get selEnd()
    {
        var ret;
        var successCB = function(_val)
        {
            ret = _val;
        };
        var errorCB = function()
        {
            ret = undefined;
        };
        
        require('cordova/exec')(successCB, errorCB, "Event", "getSelEnd", []);
        return ret;
    },
    
    /*
     * get & set value
     */
    get value()
    {
        var ret;
        var successCB = function(_val)
        {
            ret = _val;
        };
        var errorCB = function()
        {
            ret = undefined;
        };
        
        require('cordova/exec')(successCB, errorCB, "Event", "getValue", []);
        return ret;
    },
    set value(_val)
    {
        if (_val == undefined || _val == null)
            _val = "";
        
        var args = {};
        if (isNullOrUndefined(_val))
            args.val = "";
        else
            args.val = _val.toString();
        require('cordova/exec')(null, null, "Event", "setValue", [args]);
    },
    
    /*
     * get will commit
     */
    get willCommit()
    {
        var ret;
        var successCB = function(_val)
        {
            if (_val == 1)
                ret = true;
            else
                ret = false;
        };
        var errorCB = function()
        {
            ret = undefined;
        };
        
        require('cordova/exec')(successCB, errorCB, "Event", "getWillCommit", []);
        return ret;
    },
    
    /*
     * get silence error
     */ 
    get silenceErrors()
    {
        var ret;
        var successCB = function(_val)
        {
            if (_val == 1)
                ret = true;
            else
                ret = false;
        };
        var errorCB = function()
        {
            ret = undefined;
        };
        
        require('cordova/exec')(successCB, errorCB, "Event", "getSilenceErrors", []);
        return ret;
    },
    
    /*
     * get target name
     */
    get targetName()
    {
        var ret;
        var successCB = function(_val)
        {
            ret = _val;
        };
        var errorCB = function()
        {
            ret = undefined;
        };
        
        require('cordova/exec')(successCB, errorCB, "Event", "getTargetName", []);
        return ret;
    },
    
    /*
     * get source field
     */
    get source()
    {
        var ret;
        var successCB = function(_name)
        {
            ret = new Field(_name);
        };
        var errorCB = function()
        {
            ret = undefined;
        };
        
        require('cordova/exec')(successCB, errorCB, "Event", "getSource", []);
        return ret;
    }
};

var event = new Event();