/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * ___________________
 *
 * Copyright 2012 Adobe Systems Incorporated
 * All Rights Reserved.
 *
 * NOTICE: All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any. The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *
 **************************************************************************/

// Constructor
function Field(name)
{
    this.name = name;
};

Field.prototype = 
{
    get value()
    {
        var ret;
        var args = {};
        args.name = this.name;
        
        var successCB = function(_val)
        {
            if ((typeof _val == 'number' || !isNaN(_val)) && _val != "")
                ret = parseFloat(_val);
            else
                ret = _val;
        };
        var errorCB = function()
        {
            ret = undefined;
        };
        
        require('cordova/exec')(successCB, errorCB, "Field", "getValue", [args]);
        return ret;
    },
    
    set value(_val)
    {
        var args = {};
        args.name = this.name;
        
        if (isNullOrUndefined(_val))
            args.val = "";
        else
            args.val = _val.toString();
        
        require('cordova/exec')(null, null, "Field", "setValue", [args]);
    }
};

Field.prototype.getArray = function()
{
    var ret = new Array();
    var successCB = function(_val)
    {
     	if (!isNullOrUndefined(_val))
     	{
     		// iterate array of field names and create field objects
			for (var i = 0; i<_val.length; i++)
			{
				ret[i] = new Field(_val[i]);
			}
		}
    };
    var errorCB = function()
    {
        ret = undefined;
    };
    
    var args = {};
    args.name = this.name;
    require('cordova/exec')(successCB, errorCB, "Field", "getArray", [args]);
    return ret;
};

Field.prototype.setFocus = function()
{
    var args = {};
    args.name = this.name;
    require('cordova/exec')(null, null, "Field", "setFocus", [args]);
};

